--     __           _         _            _   _      
--  /\ \ \__ _ _ __| | ____ _| | ___ _ __ | |_(_) ___ 
-- /  \/ / _` | '__| |/ / _` | |/ _ \ '_ \| __| |/ __|
--/ /\  / (_| | |  |   < (_| | |  __/ |_) | |_| | (__ 
--\_\ \/ \__,_|_|  |_|\_\__,_|_|\___| .__/ \__|_|\___|
--                                  |_|               
-- /Narkaleptic/              narkaleptic@mainelan.net
--          Vehicle Control Unit v2.2.6

include( "autorun/shared/sh_vcu.lua" )

language.Add( "Vehicle Control Unit", "Vehicle Control Unit" )

language.Add( "VCUNotFound", "No VCU Found" )
language.Add( "VCUAttach", "Attached VCU" )
language.Add( "VCURemove", "Removed VCU" )
language.Add( "VCUEject", "Ejected player from VCU" )
language.Add( "VCUEjectVictim", "You have been ejected from the VCU" )
language.Add( "VCUInUse", "This VCU is in use" )
language.Add( "VCUNotInUse", "This VCU is not in use" )
language.Add( "VCUNotYours", "You do not own this VCU" )
language.Add( "VCUSelected", "Selected VCU" )
language.Add( "VCUWireCreate", "Created VCU Wire Beacon" )
language.Add( "VCUCancelled", "Cancelled" )
language.Add( "VCUUpdated", "Update VCU Settings" )
language.Add( "VCUFailed", "Failed to attach VCU" )
language.Add( "VCUCopied", "Settings copied from VCU" )

language.Add( "Forward", "Forward" )
language.Add( "Backward", "Backward" )
language.Add( "Left", "Left" )
language.Add( "Right", "Right" )
language.Add( "Jump", "Jump" )
language.Add( "Duck", "Duck" )
language.Add( "Speed", "Speed" )
language.Add( "Walk", "Walk" )
language.Add( "Reload", "Reload" )
language.Add( "Zoom", "Zoom" )
language.Add( "Attack1", "Attack 1" )
language.Add( "Attack2", "Attack 2" )

language.Add( "Vcu_Label_0", "Select mappings for the keys and enter a description\nof what this key does in your contraption." )
language.Add( "Vcu_Label_1", "To disable a numkey for a mapping select the double-\nclick a key twice." )
language.Add( "Vcu_UnmapAll", "Unmap All" )
language.Add( "Vcu_UnmapAll_Desc", "Unmap all keys and remove descriptions." )
language.Add( "Vcu_EjectAll", "Eject All" )
language.Add( "Vcu_EjectAll_Desc", "Eject everyone from your VCUs." )
language.Add( "Vcu_CopySettings", "Copy Settings" )
language.Add( "Vcu_CopySettings_Desc", "Copy settings from targetted VCU into the control panel below." )
language.Add( "Vcu_Description", "Description:" )
language.Add( "Vcu_IgnoreMap", "Show All:" )
language.Add( "Vcu_IgnoreMap_Desc", "Always display keys in HUD that have a description." )
language.Add( "Vcu_Forward", "Forward:" )
language.Add( "Vcu_Backward", "Backward:" )
language.Add( "Vcu_MoveLeft", "Strafe Left:" )
language.Add( "Vcu_MoveRight", "Strafe Right:" )
language.Add( "Vcu_Jump", "Jump:" )
language.Add( "Vcu_Duck", "Duck:" )
language.Add( "Vcu_Speed", "Speed:" )
language.Add( "Vcu_Walk", "Walk:" )
language.Add( "Vcu_Reload", "Reload:" )
language.Add( "Vcu_Zoom", "Zoom:" )
language.Add( "Vcu_Attack1", "Attack 1:" )
language.Add( "Vcu_Attack2", "Attack 2:" )
language.Add( "Vcu_About", "Created by Narkaleptic\nnarkaleptic@mainelan.net" )
language.Add( "VcuWire_About", "Created by Narkaleptic\nnarkaleptic@mainelan.net" )

language.Add( "gmod_vehicle_control", "Vehicle Control Unit" )
language.Add( "gmod_vcu_wire", "Vehicle Control Unit Wire Beacon" )

language.Add( "VehicleControlUnitWire", "Vehicle Control Unit Wire" )
language.Add( "Tool_vcu_wire_name", "Vehicle Control Unit - Wire Beacon" )
language.Add( "Tool_vcu_wire_desc", "Create a wire interface for a vehicle control unit." )
language.Add( "Tool_vcu_wire_0", "Left-Click: Select a vehicle with a VCU attached." )
language.Add( "Tool_vcu_wire_1", "Left-Click: Place the beacon. Right-Click: Cancel." )

language.Add( "Undone_vcu_wire", "Undone Vehicle Control Unit Wire Beacon" )
language.Add( "Cleanup_vcu_wire", "Vehicle Control Unit Wire Beacons" )
language.Add( "Cleaned_vcu_wire", "Cleaned up all Vehicle Control Unit Wire Beacons" )
language.Add( "SBoxLimit_vcu_wire", "You have hit the Vehicle Control Unit Wire Beacon limit!" )

language.Add( "VehicleControlUnit", "Vehicle Control Unit" )
language.Add( "Tool_vehicle_control_name", "Vehicle Control Unit" )
language.Add( "Tool_vehicle_control_desc", "Create a control unit for a vehicle." )
language.Add( "Tool_vehicle_control_0", "Left-Click: Inject/update a VCU in a vehicle. Right-Click: Eject current user. Reload: Remove VCU." )

language.Add( "Undone_vehicle_control", "Undone Vehicle Control Unit" )
language.Add( "Cleanup_vehicle_control", "Vehicle Control Units" )
language.Add( "Cleaned_vehicle_control", "Cleaned up all Vehicle Control Units" )
language.Add( "SBoxLimit_vehicle_control", "You have hit the Vehicle Control Unit limit!" )
		
Vcu_Binding_Names = {
	{"Forward", 		"forward", 		IN_FORWARD},
	{"Backward", 		"backward",		IN_BACK},
	{"Left", 			"left",			IN_MOVELEFT},
	{"Right", 			"right",		IN_MOVERIGHT},
	{"Jump", 			"jump",			IN_JUMP}, 
	{"Duck", 			"duck",			IN_DUCK}, 
	{"Speed", 			"speed",		IN_SPEED}, 
	{"Walk", 			"walk",			IN_WALK}, 
	{"Reload",			"reload",		IN_RELOAD},
	{"Zoom",			"zoom",			IN_ZOOM},
	{"Attack1", 		"attack1", 		IN_ATTACK}, 
	{"Attack2", 		"attack2",		IN_ATTACK2}
}

local VcuHud = {}

local function Vcu_HudPaint()
    local player = LocalPlayer()
    
    if (!player:Alive()) then return end
    
    local vcu = player.Entity:GetNetworkedEntity("vcu")
	    
	if (!IsValidEntity(vcu)) then
		return
	end

	-- set the font for the hud
	local font = "GModNotify"
	surface.SetFont( font )

	-- determine character width
	local cw, ch = surface.GetTextSize("X")
    
	-- recalculate everything if in a different vcu or it has been updated
	if ( VcuHud.vcu != vcu || VcuHud.LastUpdate < vcu:GetNetworkedFloat("updated") ) then
		VcuHud.Caption = vcu:GetNetworkedString( "caption" ) 
		if ( !VcuHud.Caption || VcuHud.Caption == "" ) then VcuHud.Caption = "Vehicle Control Unit" end
    
		VcuHud.Owner = vcu:GetNetworkedString( "owner" ) 
		if ( !VcuHud.Owner || VcuHud.Owner == "" ) then VcuHud.Owner = "Unknown Owner" end
	
		VcuHud.LastUpdated = vcu:GetNetworkedFloat( "updated" )
		
		VcuHud.Bindings = {}	
		for _, v in pairs(Vcu_Binding_Names) do
			local desc = vcu:GetNetworkedString(v[2])
			if (desc && desc != "") then
				table.insert(VcuHud.Bindings, {v[1], desc, v[3]})
			end
		end
		
		local caption_width, _ = surface.GetTextSize( VcuHud.Caption ) + cw * 2
		local owner_width, _ = surface.GetTextSize( VcuHud.Owner ) + cw * 2
		local min_width = 0
		if ( owner_width > caption_width ) then 
			min_width = owner_width 
		else
			min_width = caption_width
		end

		
		-- dynamically determine the width of the hud panel
		local key_col = 0
		local desc_col = 0
		for _, v in pairs(VcuHud.Bindings) do
			local w, _ = surface.GetTextSize(v[1])
			if (key_col < w) then key_col = w end
			
			if (v[2]) then
				local w, _ = surface.GetTextSize(v[2])
				if (desc_col < w) then desc_col = w end
			end
		end
		
		-- if the caption or owner strings are too long, expand the columns
		if ( min_width > (key_col + cw + desc_col) ) then
			local addw = (min_width - (key_col + cw + desc_col)) / 2
			key_col = key_col + addw
			desc_col = desc_col + addw
		end
		
		VcuHud.KeyCol = key_col
		VcuHud.DescCol = desc_col
		
		VcuHud.Width = key_col + desc_col + cw * 3
		VcuHud.Left = VcuHud.Width + cw * 2 
		VcuHud.Height = ch * 4 + (#VcuHud.Bindings * ch * 1.5)
		VcuHud.Top = VcuHud.Height + 2 * ch
	end

	-- determine bounds
	local w = VcuHud.Width
	local x = ScrW() - VcuHud.Left 
	local h = VcuHud.Height
	local y = ScrH() - VcuHud.Top
	local key_col = VcuHud.KeyCol
	local desc_col = VcuHud.DescCol
	
	if (#VcuHud.Bindings == 0) then h = h + ch * 1.5 end

	-- draw boxes
	draw.RoundedBox(4, x, y, w, h, Color(64, 64, 64, 128))
	draw.RoundedBox(2, x+2, y+2, w-4, ch * 1.5, Color(128, 128, 170, 128))

	draw.RoundedBox(2, x+2, y+4 + ch * 1.5 , w-4, h - ch * 3 - 7, Color(196, 196, 196, 128))
	
	-- draw title
	draw.SimpleTextOutlined(
		VcuHud.Caption, font, 
		x + w / 2, y + 1 + ch * 0.75, Color(255,255,255,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER, 1, Color(64,64,96,255))
	y = y + ch * 2.25
	
	local clr1_down, clr2_down = Color(255,255,128,255), Color(225,225,100,255)
	local clr1_up, clr2_up = Color(255,255,255,255), Color(225,225,225,255)
	local clr1_trn, clr2_trn = Color(255,255,200,255), Color(225,225,160,255)
	
	-- draw text for keys and descriptions
	if (#VcuHud.Bindings > 0) then
		for k, v in pairs(VcuHud.Bindings) do
			local color1, color2
			if (player:KeyDown(v[3])) then
				if (player:KeyDownLast(v[3])) then
					color1, color2 = clr1_down, clr2_down
				else
					color1, color2 = clr1_trn, clr2_trn
				end
			else
				if (player:KeyDownLast(v[3])) then
					color1, color2 = clr1_trn, clr2_trn
				else				
					color1, color2 = clr1_up, clr2_up
				end
			end
			
			draw.SimpleText("#" .. v[1], font, x + cw, y, color1, 0, 3)
			draw.SimpleText(v[2], font, x + cw * 2 + key_col, y, color2, 0, 3)
			y = y + ch * 1.5
		end
	else
		draw.SimpleText("Nothing", font, x + cw, y, Color(255,255,255,255), 0, 3)
		y = y + ch * 1.5	
	end
	
	-- draw owner
	y = y + ch * 0.8
	draw.SimpleText(VcuHud.Owner, font, x + w / 2, y+1, Color(200,200,200,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
end

hook.Add("HUDPaint", "Vcu_HudPaint", Vcu_HudPaint)

-- hide the vehicle hud if we are in a vcu, it gets in our way
function Vcu_HideVehicleHud(name)
    local player = LocalPlayer()
    
    local vcu = player.Entity:GetNetworkedEntity("vcu")
	    
	if (!IsValidEntity(vcu)) then
		return
	end

	if (name == "CHudHintDisplay") then return false end
end
hook.Add( "HUDShouldDraw", "Vcu_HideVehicleHud", Vcu_HideVehicleHud )  

if (!IsValidEntity) then
	function IsValidEntity(entity)
		if (entity && entity.IsValid && entity:IsValid()) then
			return true
		end
		
		return false
	end
end

local function Vcu_TipMessage( Message )

	local Text = "#" .. Message:ReadString()
	local Failure = Message:ReadBool()
	
	if ( Text != "" ) then
		GAMEMODE:AddNotify( Text, NOTIFY_GENERIC, 3	 )
	end
	
	if ( Failure ) then
		surface.PlaySound( "buttons/button16.wav" )
	else
		surface.PlaySound( "buttons/button14.wav" )
	end

end
usermessage.Hook( "VcuTipMessage", Vcu_TipMessage )