--     __           _         _            _   _      
--  /\ \ \__ _ _ __| | ____ _| | ___ _ __ | |_(_) ___ 
-- /  \/ / _` | '__| |/ / _` | |/ _ \ '_ \| __| |/ __|
--/ /\  / (_| | |  |   < (_| | |  __/ |_) | |_| | (__ 
--\_\ \/ \__,_|_|  |_|\_\__,_|_|\___| .__/ \__|_|\___|
--                                  |_|               
-- /Narkaleptic/              narkaleptic@mainelan.net
--          Vehicle Control Unit v2.2.6

AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

ENT.WireDebugName = "Vehicle Control Unit"

include("shared.lua")

local MODEL = Model("models/jaanus/wiretool/wiretool_siren.mdl")

-- modified for wire
local VcuPropertyNames = { "InUse", "Forward", "Backward", "Left", "Right", "Jump", "Duck", "Speed", "Walk", "Reload", "Zoom", "Attack1", "Attack2" }

function ENT:Initialize()
	self.Entity:SetModel(MODEL)
	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)
	self.Entity:SetSolid(SOLID_VPHYSICS)

	--self.Inputs = Wire_CreateInputs( self.Entity, { "Disabled" } )
	self.Outputs = Wire_CreateOutputs(self.Entity, VcuPropertyNames)
	self.Trigger = 0
end

function ENT:Remove()
	self:SetVcu(nil)
end

function ENT:Listen(entity, key, value)
	Wire_TriggerOutput(self.Entity, key, value)
	self:ShowOutput(key)
end

function ENT:ShowOutput(key)
	local msg = ""
	for _, output in pairs(self.Outputs) do		
		if (output.Name != "" && output.Value != 0) then
			if (msg != "") then msg = msg .. "," end

			-- Conserve bandwidth for most keys
			if ( msg == "InUse" || msg == "Attack1" || msg == "Attack2" ) then
				msg = msg .. output.Name
			else
				msg = msg .. string.Left(output.Name, 2)
			end
			
		end
	end 
	
	self:SetOverlayText( msg )
end
