--     __           _         _            _   _      
--  /\ \ \__ _ _ __| | ____ _| | ___ _ __ | |_(_) ___ 
-- /  \/ / _` | '__| |/ / _` | |/ _ \ '_ \| __| |/ __|
--/ /\  / (_| | |  |   < (_| | |  __/ |_) | |_| | (__ 
--\_\ \/ \__,_|_|  |_|\_\__,_|_|\___| .__/ \__|_|\___|
--                                  |_|               
-- /Narkaleptic/              narkaleptic@mainelan.net
--          Vehicle Control Unit v2.2.6

ENT.Type 			= "anim"
ENT.Base 			= "base_wire_entity"

ENT.PrintName		= "Vehicle Control Unit Wire Beacon"
ENT.Author			= "Narkaleptic"
ENT.Contact			= "narkaleptic@mainelan.net"
ENT.Purpose			= "Wire interface to Vehicle Control Unit."
ENT.Instructions	= "Place beacon (left click) and then link (right click) to vehicle with a vcu."

ENT.Spawnable		= false
ENT.AdminSpawnable	= false

function ENT:SetOn(boolean)
	self.Entity:SetNetworkedBool("On", boolean, true)
end

function ENT:IsOn()
	return self.Entity:GetNetworkedBool("On")
end

function ENT:SetVcu(entity)
	local current = self.Entity:GetNetworkedEntity("Vcu", NULL)
	if (Vcu_IsValidEntity(current)) then
		current.GetTable():DetachListener(self.Entity)
	end
	
	self.Entity:SetNetworkedEntity("Vcu", entity, true)
	if (Vcu_IsValidEntity(entity)) then
		entity.GetTable():AttachListener(self.Entity)
	end
end

function ENT:GetVcu()
	return self.Entity:GetNetworkedEntity("Vcu", NULL)
end
