--     __           _         _            _   _      
--  /\ \ \__ _ _ __| | ____ _| | ___ _ __ | |_(_) ___ 
-- /  \/ / _` | '__| |/ / _` | |/ _ \ '_ \| __| |/ __|
--/ /\  / (_| | |  |   < (_| | |  __/ |_) | |_| | (__ 
--\_\ \/ \__,_|_|  |_|\_\__,_|_|\___| .__/ \__|_|\___|
--                                  |_|               
-- /Narkaleptic/              narkaleptic@mainelan.net
--             Gravity v1.0.0

TOOL.Category 		= "Construction"
TOOL.Name 			= "#Gravity"
TOOL.Command		= nil
TOOL.ConfigName 	= ""

TOOL.ClientConVar["enabled"] = 1
TOOL.ClientConVar["percentage"] = 1.00

if (CLIENT) then
	language.Add("Tool_gravity_name", "Gravity")
	language.Add("Tool_gravity_desc", "Change the gravity forces applied to an entity.")
	
	language.Add("Tool_gravity_0", "Left-Click: Apply gravity properties.")
end

function TOOL.BuildCPanel(cp)
	cp:AddControl("Header", {Text = "#Tool_gravity_name", Description = "#Tool_gravity_desc"})

    cp:AddControl("ComboBox", {
        Label = "#Presets",
        MenuButton = "1",
        Folder = "gravity",

        Options = {
            Default = {
                gravity_enabled = 1,
            	gravity_percentage = 1
            }
        },
        CVars = {
			[0] = "gravity_enabled",
			[1] = "gravity_percentage"
		}
	})
	
	cp:AddControl( "Checkbox", {Label = "Enabled", Command = "gravity_enabled"})
	
	cp:AddControl( "Slider", {Label = "Modifier", Description = "Percent of standard gravity applied to the entity.", Type = "Float", Min = "-1", Max = "2", Command = "gravity_percentage"})   
end

function TOOL:LeftClick(trace)
	if (!trace.Entity) then return false end
	if (!trace.Entity:IsValid()) then return false end
	if (trace.Entity:IsPlayer()) then return false end

	if (SERVER && !util.IsValidPhysicsObject(trace.Entity, trace.PhysicsBone)) then return false end

	local enabled = self:GetClientNumber("enabled")
	local percentage = self:GetClientNumber("percentage")
	
	if (enabled == 0) then
		trace.Entity:GetPhysicsObject():EnableGravity(false)
	else
		trace.Entity:GetPhysicsObject():EnableGravity(true)
	end
	
	trace.Entity:SetGravity(percentage)
	
	return true	
end
